Crystal::Macros::SymbolLiteral - Crystal 1.19.1

# class Crystal::Macros::SymbolLiteral

- Crystal::Macros::SymbolLiteral
- Crystal::Macros::ASTNode

##
Overview

A symbol literal.

##
Defined in:

compiler/crystal/macros.cr

##
Instance Method Summary

- #+(other : StringLiteral | CharLiteral) : SymbolLiteral

  Similar to `String#+`.

- #=~(range : RegexLiteral) : BoolLiteral

  Similar to `String#matches?`.

- #[](range : RangeLiteral) : SymbolLiteral

  Similar to `String#[]`.

- #camelcase(*, lower : BoolLiteral = false) : SymbolLiteral

  Similar to `String#camelcase`.

- #capitalize : SymbolLiteral

  Similar to `String#capitalize`.

- #chars : ArrayLiteral(CharLiteral)

  Similar to `String#chars`.

- #chomp : SymbolLiteral

  Similar to `String#chomp`.

- #count(other : CharLiteral) : NumberLiteral

  Similar to `String#count`.

- #downcase : SymbolLiteral

  Similar to `String#downcase`.

- #empty? : BoolLiteral

  Similar to `String#empty?`.

- #ends_with?(other : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#ends_with?`.

- #gsub(regex : RegexLiteral, & : StringLiteral, ArrayLiteral(StringLiteral | NilLiteral) -> _) : SymbolLiteral

  Similar to `String#gsub(pattern, options, &)`.

- #gsub(regex : RegexLiteral, replacement : StringLiteral) : SymbolLiteral

  Similar to `String#gsub`.

- #id : MacroId

  Returns a `MacroId` for this string's contents.

- #includes?(search : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#includes?`.

- #lines : ArrayLiteral(StringLiteral)

  Similar to `String#lines`.

- #match(regex : RegexLiteral) : HashLiteral(NumberLiteral | StringLiteral, StringLiteral | NilLiteral)

  Matches the given regex against this string and returns a capture hash, or `nil` if a match cannot be found.

- #scan(regex : RegexLiteral) : ArrayLiteral(HashLiteral(NumberLiteral | StringLiteral, StringLiteral | NilLiteral))

  Returns an array of capture hashes for each match of regex in this string.

- #size : NumberLiteral

  Similar to `String#size`.

- #split(node : StringLiteral) : ArrayLiteral(StringLiteral)

  Similar to `String#split(String)`.

- #split(node : CharLiteral) : ArrayLiteral(StringLiteral)

  Similar to `String#split(Char)`.

- #split(node : ASTNode) : ArrayLiteral(StringLiteral)

  Similar to `String#split(String)`.

  DEPRECATED Use `#split(StringLiteral)` instead

- #split(node : RegexLiteral) : ArrayLiteral(StringLiteral)

  Similar to `String#split(Regex)`.

- #split : ArrayLiteral(StringLiteral)

  Similar to `String#split()`.

- #starts_with?(other : StringLiteral | CharLiteral) : BoolLiteral

  Similar to `String#starts_with?`.

- #strip : SymbolLiteral

  Similar to `String#strip`.

- #titleize : SymbolLiteral

  Similar to `String#titleize`.

- #to_i(base = 10)

  Similar to `String#to_i`.

- #to_utf16 : ASTNode

  Returns an expression that evaluates to a slice literal containing the UTF-16 code units of this string, plus an extra trailing null character.

  EXPERIMENTAL Slice literals are still under development. Join the discussion at #2886.

- #tr(from : StringLiteral, to : StringLiteral) : SymbolLiteral

  Similar to `String#tr`.

- #underscore : SymbolLiteral

  Similar to `String#underscore`.

- #upcase : SymbolLiteral

  Similar to `String#upcase`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, doc : StringLiteral doc, doc_comment : MacroId doc_comment, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, is_a?(type : TypeNode) : BoolLiteral is_a?, line_number : StringLiteral | NilLiteral line_number, nil? : BoolLiteral nil?, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize, warning(message : StringLiteral) : NilLiteral warning

##
Instance Method Detail

def +(other : StringLiteral | CharLiteral) : SymbolLiteral #

Similar to `String#+`.

def =~(range : RegexLiteral) : BoolLiteral #

Similar to `String#matches?`.

def [](range : RangeLiteral) : SymbolLiteral #

Similar to `String#[]`.

def camelcase(*, lower : BoolLiteral = false) : SymbolLiteral #

Similar to `String#camelcase`.

def capitalize : SymbolLiteral #

Similar to `String#capitalize`.

def chars : ArrayLiteral(CharLiteral) #

Similar to `String#chars`.

def chomp : SymbolLiteral #

Similar to `String#chomp`.

def count(other : CharLiteral) : NumberLiteral #

Similar to `String#count`.

def downcase : SymbolLiteral #

Similar to `String#downcase`.

def empty? : BoolLiteral #

Similar to `String#empty?`.

def ends_with?(other : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#ends_with?`.

def gsub(regex : RegexLiteral, & : StringLiteral, ArrayLiteral(StringLiteral | NilLiteral) -> _) : SymbolLiteral #

Similar to `String#gsub(pattern, options, &)`.

NOTE The special variables `$~` and `$1`, `$2`, ... are not supported.

def gsub(regex : RegexLiteral, replacement : StringLiteral) : SymbolLiteral #

Similar to `String#gsub`.

def id : MacroId #

Returns a `MacroId` for this string's contents.

def includes?(search : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#includes?`.

def lines : ArrayLiteral(StringLiteral) #

Similar to `String#lines`.

def match(regex : RegexLiteral) : HashLiteral(NumberLiteral | StringLiteral, StringLiteral | NilLiteral) #

Matches the given regex against this string and returns a capture hash, or `nil` if a match cannot be found.

The capture hash has the same form as `Regex::MatchData#to_h`.

def scan(regex : RegexLiteral) : ArrayLiteral(HashLiteral(NumberLiteral | StringLiteral, StringLiteral | NilLiteral)) #

Returns an array of capture hashes for each match of regex in this string.

Capture hashes have the same form as `Regex::MatchData#to_h`.

def size : NumberLiteral #

Similar to `String#size`.

def split(node : StringLiteral) : ArrayLiteral(StringLiteral) #

Similar to `String#split(String)`.

def split(node : CharLiteral) : ArrayLiteral(StringLiteral) #

Similar to `String#split(Char)`.

def split(node : ASTNode) : ArrayLiteral(StringLiteral) #

Similar to `String#split(String)`.

DEPRECATED Use `#split(StringLiteral)` instead

def split(node : RegexLiteral) : ArrayLiteral(StringLiteral) #

Similar to `String#split(Regex)`.

def split : ArrayLiteral(StringLiteral) #

Similar to `String#split()`.

def starts_with?(other : StringLiteral | CharLiteral) : BoolLiteral #

Similar to `String#starts_with?`.

def strip : SymbolLiteral #

Similar to `String#strip`.

def titleize : SymbolLiteral #

Similar to `String#titleize`.

def to_i(base = 10) #

Similar to `String#to_i`.

def to_utf16 : ASTNode #

Returns an expression that evaluates to a slice literal containing the UTF-16 code units of this string, plus an extra trailing null character. This null character is not part of the slice, but ensures that calling `#to_unsafe` always results in a properly null-terminated C string.

    (::Slice(::UInt16).literal(97_u16, 98_u16, 99_u16, 55357_u16, 56834_u16, 0_u16))[0, 5] # => ::Slice(::UInt16).literal(97, 98, 99, 55357, 56834, 0)[0, 5]

WARNING The return value is not necessarily a literal node.

EXPERIMENTAL Slice literals are still under development. Join the discussion at #2886.

def tr(from : StringLiteral, to : StringLiteral) : SymbolLiteral #

Similar to `String#tr`.

def underscore : SymbolLiteral #

Similar to `String#underscore`.

def upcase : SymbolLiteral #

Similar to `String#upcase`.